<?xml version="1.0" encoding="UTF-8"?>
<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
		<meta charset="utf-8" />
		<title>Dokumentation 1 der Template-Engine</title>
		<link rel="stylesheet" type="text/css" href="stylesheet.css" id="style-standard" />
	</head>
	<body class="demo">
		
		<h1>Allgemeine Hinweise zur <em>Template-Engine</em> Version 2</h1>
		
		<p>Die neue TPL-Template-Engine wurde deutlich erweitert. Neben den bisherigen reinen Textvariablen in
			doppelt-geschweiften Klammern (z.B. <code>{{&#x200A;TITEL&#x200A;}}</code>) sind nun auch geparste
			Element-Abfragen und der Aufruf von benannten XSLT-Templates möglich.
		</p>
		<p>Die Möglichkeiten die sich dadurch ergeben sind sehr vielfältig, sie sind jedoch an einigen Stellen
			auch mit Einschränkungen verbunden.
		</p>
		<p>Eine dieser Einschränkungen, die aber auch schon früher bestanden hat, ist, dass in TPL-Template-Dateien
			keine HTML-Entities (z.B. <code>&amp;&#x200A;nbsp;</code>) verwendet werden dürfen!</p>
		
		<p>&#x00A0;</p>
		<p>Eine vollständige und u.U. auch aktuellere Dokumentation der TPL-Engine finden Sie im Web unter <a href="https://tools.parsx.de/doku/v3/#epub_template-engine.html">https://tools.parsx.de/doku/v3/#epub_template-engine.html</a></p>
		
		<p>&#x00A0;</p>
		<hr/>
		
		<!-- ================================================================================================= -->
		
		<h2>Textvariablen</h2>
		
		<p>Textvariablen in doppelt-geschweiften Klammern (z.B. <code>{{&#x200A;TITEL&#x200A;}}</code>) geben den Inhalt des
			entsprechenden Metadatenfelds in Plain-Text zurück. Es wird kein MarkUp prozessiert und ausgegeben!</p>
		<p>Enthält das Element <code>&#x3C;meta_titel></code> einen Zeilenumbruch mittels <code>&#x3C;br/></code>-Element, so wird er NICHT
			ausgegeben!</p>
		
		<div class="einschub infobox" id="textVariablen">
			<p><b>Erlaubt sind die folgenden Textvariablen:</b><br/>{{&#x200A;TITEL&#x200A;}} | {{&#x200A;UNTERTITEL&#x200A;}} | {{&#x200A;ISBN&#x200A;}} | {{&#x200A;ISBN-clean&#x200A;}} | {{&#x200A;eISBN&#x200A;}} | {{&#x200A;eISBN-clean&#x200A;}} | {{&#x200A;DOI&#x200A;}} | {{&#x200A;URN&#x200A;}} | {{&#x200A;ID&#x200A;}} | {{&#x200A;LOVELYBOOKS.ALLEAUTOREN&#x200A;}} | {{&#x200A;LOVELYBOOKS.AUTORENLINK&#x200A;}} | {{&#x200A;UEBERSETZER&#x200A;}} | {{&#x200A;UEBERSETZER1&#x200A;}} | {{&#x200A;UEBERSETZER2&#x200A;}} | {{&#x200A;UEBERSETZER3&#x200A;}} | {{&#x200A;UEBERSETZER4&#x200A;}} | {{&#x200A;UEBERSETZER5&#x200A;}} | {{&#x200A;ILLUSTRATOREN&#x200A;}} | {{&#x200A;ILLUSTRATOR&#x200A;}} | {{&#x200A;ILLUSTRATOR1&#x200A;}} | {{&#x200A;ILLUSTRATOR2&#x200A;}} | {{&#x200A;ILLUSTRATOR3&#x200A;}} | {{&#x200A;ILLUSTRATOR4&#x200A;}} | {{&#x200A;ILLUSTRATOR5&#x200A;}} | {{&#x200A;GATTUNG&#x200A;}} | {{&#x200A;eLOGO&#x200A;}} | {{&#x200A;LOGO&#x200A;}} | {{&#x200A;HERAUSGEBER&#x200A;}} | {{&#x200A;HERAUSGEBER1&#x200A;}} | {{&#x200A;HERAUSGEBER2&#x200A;}} | {{&#x200A;HERAUSGEBER3&#x200A;}} | {{&#x200A;HERAUSGEBER4&#x200A;}} | {{&#x200A;HERAUSGEBER5&#x200A;}} | {{&#x200A;AUTOREN&#x200A;}} | {{&#x200A;AUTOR&#x200A;}} | {{&#x200A;AUTOR1&#x200A;}} | {{&#x200A;AUTOR2&#x200A;}} | {{&#x200A;AUTOR3&#x200A;}} | {{&#x200A;AUTOR4&#x200A;}} | {{&#x200A;AUTOR5&#x200A;}} | {{&#x200A;CO-AUTOREN&#x200A;}} | {{&#x200A;CO-AUTOR1&#x200A;}} | {{&#x200A;CO-AUTOR2&#x200A;}} | {{&#x200A;CO-AUTOR3&#x200A;}} | {{&#x200A;CO-AUTOR4&#x200A;}} | {{&#x200A;CO-AUTOR5&#x200A;}} | {{&#x200A;DL-NAME&#x200A;}}</p>
		</div>
		
		<p>&#x00A0;</p>
		
		<p><strong>Beispiel 1:</strong></p>
		
		<div class="einschub code">
			<pre>&#x3C;meta_titel>Ein &#x3C;kursiv>ziemlich&#x3C;/kursiv> langer Beispieltitel&#x3C;br/>für ein E-Book!&#x3C;/meta_titel></pre>
			<p><code>{{&#x200A;TITEL&#x200A;}}</code>: Ein ziemlich langer Beispieltitelfür ein E-Book!</p>
		</div>
		<p><em>MarkUp wird ersatzlos entfernt. Dadurch kann es zu Darstellungsfehlern kommen!</em></p>
		<p>&#x00A0;</p>
		
		<p><strong>Beispiel 2:</strong></p>
		
		<div class="einschub code">
			<pre>&#x3C;meta_titel>Ein &#x3C;kursiv>ziemlich&#x3C;/kursiv> langer Beispieltitel &#x3C;br/>für ein E-Book!&#x3C;/meta_titel></pre>
			<p><code>{{&#x200A;TITEL&#x200A;}}</code>: Ein ziemlich langer Beispieltitel für ein E-Book!</p>
		</div>
		<p><em>Behelfslösung mit zusätzlichem Leerzeichen VOR dem &#x3C;br/>-Element.</em></p>
		
		<p>&#x00A0;</p>
		<hr/>
		
		
		<!-- ================================================================================================= -->
		
		<h2>Element-Abfragen</h2>
		
		<p>Um diese Schwäche der Textvariablen zu umgehen, sind seit Version 2 der Template-Engine Element-Abfragen möglich.</p>
		
		<p>&#x00A0;</p>
		
		<p>Element-Abfragen werden über das spezifische Attribut <code>@valueOf="Element"</code> an einem
			beliebigen HTML-Element im TPL-Template erzeugt.</p>
		
		<div class="einschub infobox" id="elementAufrufe">
			<p><b>Erlaubt sind lediglich die folgenden Element-Aufrufe:</b><br/>'meta_titel', 'meta_untertitel', 'meta_e-isbn', 'meta_isbn', 'meta_doi', 'meta_urn', 'meta_id', 'meta_uebersetzer-abs', 'meta_uebersetzer-1', 'meta_uebersetzer-2', 'meta_uebersetzer-3', 'meta_uebersetzer-4', 'meta_uebersetzer-5', 'meta_illustratoren-abs', 'meta_illustrator-1', 'meta_illustrator-2', 'meta_illustrator-3', 'meta_illustrator-4', 'meta_illustrator-5', 'meta_gattung', 'meta_herausgeber-abs', 'meta_herausgeber-1', 'meta_herausgeber-2', 'meta_herausgeber-3', 'meta_herausgeber-4', 'meta_herausgeber-5', 'meta_autoren-abs', 'meta_autor-1', 'meta_autorvorname-1', 'meta_autornachname-1', 'meta_autor-2', 'meta_autorvorname-2', 'meta_autornachname-2', 'meta_autor-3', 'meta_autorvorname-3', 'meta_autornachname-3', 'meta_autor-4', 'meta_autorvorname-4', 'meta_autornachname-4', 'meta_autor-5', 'meta_autorvorname-5', 'meta_autornachname-5', 'meta_co-autoren-abs ', 'meta_co-autor-1', 'meta_co-autorvorname-1', 'meta_co-autornachname-1', 'meta_co-autor-2', 'meta_co-autorvorname-2', 'meta_co-autornachname-2', 'meta_co-autor-3', 'meta_co-autorvorname-3', 'meta_co-autornachname-3', 'meta_co-autor-4', 'meta_co-autorvorname-4', 'meta_co-autornachname-4', 'meta_co-autor-5', 'meta_co-autorvorname-5', 'meta_co-autornachname-5', 'meta_joker-1', 'meta_joker-2', 'meta_joker-3', 'meta_joker-4', 'meta_joker-5', 'meta_copyright', 'meta_bio', 'meta_kurztext', 'meta_dl-name'</p>
		</div>
		
		<p>&#x00A0;</p>
		
		<p><strong>Beispiel:</strong></p>
		<div class="einschub code">
			<pre>&#x3C;div valueOf="meta_titel"/></pre>
			<div valueOf="meta_titel"/>
		</div>
		
		<div class="einschub code">
			<pre>&#x3C;h6>Titel ist: "&#x3C;span valueOf="meta_titel"/>"&#x3C;/h6></pre>
			<h6>Titel ist: "<span valueOf="meta_titel"/>"</h6>
		</div>
		
		<p>&#x00A0;</p>
		
		<p>Falls eine Element-Abfrage kein Ergebnis liefert, wird das Element welches das
			<code>@valueOf</code>-Attribut enthält, enfernt.</p>
		
		<p><strong>Beispiel:</strong></p>
		<div class="einschub code">
			<pre>&#x3C;div valueOf="meta_joker-5"/></pre>
			<div valueOf="meta_joker-5"/>
		</div>
		
		<p>&#x00A0;</p>
		
		<p>Falls dieses Verhalten nicht erwünscht ist, das Element also trotzdem leer erzeugt werden soll,
			kann das Sonder-Attribut <code>@preserveEmptyElement="true"</code> gesetzt werden:</p>
		
		<p><strong>Beispiel:</strong></p>
		<div class="einschub code">
			<pre>&#x3C;div valueOf="meta_joker-5" <span style="color:green;">preserveEmptyElement="true"</span>/></pre>
			<div valueOf="meta_joker-5" preserveEmptyElement="true"/>
		</div>
		
		<p>&#x00A0;</p>
		
		<p><code>@class</code> Attribute am abfragenden Element werden übernommen:</p>
		
		<p><strong>Beispiel:</strong></p>
		<div class="einschub code">
			<pre>&#x3C;div valueOf="meta_untertitel" <span style="color:green;">class="t_untertitel"</span>/></pre>
			<div valueOf="meta_untertitel" class="t_untertitel"/>
		</div>
		
		<p>&#x00A0;</p>
		
		<p>Fehlerhafte Element-Abfragen erzeugen im Oxygen-Logfile UND im EPUB eine Fehlermeldung:</p>
		
		<p><strong>Beispiel:</strong></p>
		<div class="einschub code">
			<pre>&#x3C;div valueOf="keinElement"/></pre>
			<div valueOf="keinElement" class="t_untertitel"/>
		</div>
		
		<p>&#x00A0;</p>
		
		<hr/>
		
		
		<!-- ================================================================================================= -->
		
		<h2>Aufruf von Templates</h2>
		
		<p>Templates kapseln vorgefertigte komplexe(re) XPath- und XSLT-Abfragen, die mit den oben genannten
			Möglichkeiten der Element-Abfragen nicht umzusetzen sind. Dazu gehört unter Anderem die Ausgabe des
			verlinkten Inhaltsverzeichnisses.</p>
		
		<p>&#x00A0;</p>
		
		<p>Template-Aufrufe werden über das spezifische Attribut <code>@callTemplate="template-name"</code>
			an einem beliebigen HTML-Element im TPL-Template erzeugt.</p>
			
		<div class="einschub infobox">Erlaubt sind lediglich die Aufrufe der folgenden Templates:
			<ul>
				<li><code>alleAutoren</code>
					<ul>
						<li><em>Listet alle Autoren (inkl. MarkUp), getrennt durch das im ConfigFile für Urheber definierte Trennzeichen</em></li>
					</ul>
				</li>
				<li><code>alleCoAutoren</code>
					<ul>
						<li><em>Listet alle Co-Autoren (inkl. MarkUp), getrennt durch das im ConfigFile für Urheber definierte Trennzeichen</em></li>
					</ul>
				</li>
				<li><code>alleHerausgeber</code>
					<ul>
						<li><em>Listet alle Herausgeber (inkl. MarkUp), getrennt durch das im ConfigFile für Urheber definierte Trennzeichen</em></li>
					</ul>
				</li>
				<li><code>alleUebersetzer</code>
					<ul>
						<li><em>Listet alle Übersetzer (inkl. MarkUp), getrennt durch das im ConfigFile für Urheber definierte Trennzeichen</em></li>
					</ul>
				</li>
				<li><code>alleIllustratoren</code>
					<ul>
						<li><em>Listet alle Illustratoren (inkl. MarkUp), getrennt durch das im ConfigFile für Urheber definierte Trennzeichen</em></li>
					</ul>
				</li>
				<li><code>inhaltsverzeichnis</code>
					<ul>
						<li><em>Gibt das generierte Content-Inhaltsverzeichnis aus</em></li>
						<li><em>Dieses enthält nur die eigentlichen Inhaltskapitel aus dem Hauptteil und keine Zusatzseiten wie Cover, Haupttitel, etc.</em></li>
					</ul>
				</li>
				<li><code>inhaltsverzeichnis-toc</code>
					<ul>
						<li><em>Gibt das komplette TOC-Inhaltsverzeichnis aus</em></li>
						<li><em>Dieses enthält neben den Inhaltskapiteln aus dem Hauptteil auch Zusatzseiten wie Cover, Haupttitel, etc. und entspricht damit dem Reader-TOC.</em></li>
					</ul>
				</li>
			</ul>
		</div>
		
		<p>&#x00A0;</p>
		
		<p>ACHTUNG: Falls ein Template keine Ausgabe erzeugt, z.B. wenn alle Herausgeber gelistet werden sollen, in der XML-Instanz aber kein Element <code>&#x3C;meta_herausgeber></code> existiert, dann wird das Element – im Gegensatz zum oben genannten Verhalten bei Element-Abfragen – trotzdem generiert!</p>
		
		<p>&#x00A0;</p>
		
		<p><strong>Beispiel:</strong></p>
		<div class="einschub code">
			<pre>&#x3C;div callTemplate="alleAutoren"/></pre>
			<div callTemplate="alleAutoren"/>
		</div>
		
		<p>&#x00A0;</p>
		
		<p><code>@class</code> Attribute am abfragenden Element werden übernommen:</p>
		
		<p><strong>Beispiel:</strong></p>
		
		<div class="einschub code">
			<pre>&#x3C;div callTemplate="alleAutoren" <span style="color:green;">class="t_autor"</span>/></pre>
			<div callTemplate="alleAutoren" class="t_autor"/>
		</div>
	</body>
</html>