<?xml version="1.0" encoding="UTF-8"?>
<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
		<meta charset="utf-8" />
		<title>Dokumentation 2 der Template-Engine</title>
		<link rel="stylesheet" type="text/css" href="stylesheet.css" id="style-standard" />
	</head>
	<body class="demo">
		
		<h1>Weitere Hinweise zur <em>Template-Engine</em> Version 2</h1>
		
		<p>Neben den Template- und Element-Abfragemöglichkeiten gilt es, zwei weitere interessante Punkte zu beachten.
		Über spezielle Elemente und Attribute im HTML kann zum einen der TOC-Eintrag, zum anderen aber auch die Einbindung
		der gesamten Seite selbst gesteuert werden!</p>
		
		
		<!-- ================================================================================================= -->
		
		<h2>TOC-Eintrag</h2>
		
		<p>Für die Seteuerung des TOC-Eintrags ist das HTML-Element &#x3C;title> zuständig. Ist es vorhanden und befüllt
			wird automatisch ein TOC-Eintrag erstellt dessen Wert dem des &#x3C;title>-Elements entspricht.</p>
		<p>&#x00A0;</p>
		
		<p><strong>Beispiel:</strong></p>
		
		<div class="einschub code">
			<pre>&#x3C;head><br/>    &#x3C;title>Über das Buch&#x3C;/title><br/>    ...</pre>
		</div>
		<p><em>Ergebnis: Der TOC-Eintrag dieser Template-Seite lautet also: <b>Über das Buch</b></em></p>
		<p>&#x00A0;</p>
		
		
		<p>Ebenso ist es möglich, Textvariablen im &#x3C;title>-Element zu verwenden:</p>
		<p>&#x00A0;</p>
		
		<p><strong>Beispiel:</strong></p>
		
		<div class="einschub code">
			<pre>&#x3C;head><br/>    &#x3C;title>Über {{&#x200A;AUTOR&#x200A;}}&#x3C;/title><br/>    ...</pre>
		</div>
		<p><em>Ergebnis: Der TOC-Eintrag dieser Template-Seite könnte also z.B: lauten: <b>Über Friedrich Schiller</b></em></p>
		<p>&#x00A0;</p>
		
		
		<p>Wird das &#x3C;title>-Element leer gelassen (es darf nicht ganz fehlen, sonst ist das XHTML invalide),
			wird auch kein TOC-Eintrag erzeugt:</p>
		<p>&#x00A0;</p>
		
		<p><strong>Beispiel:</strong></p>
		
		<div class="einschub code">
			<pre>&#x3C;head><br/>    &#x3C;title>&#x3C;/title><br/>    ...</pre>
		</div>
		
		<div class="einschub code">
			<pre>&#x3C;head><br/>    &#x3C;title/><br/>    ...</pre>
		</div>
		<p><em>Ergebnis: Die Seite taucht zwar an entsprechender Stelle im Lesefluss auf, wird aber im TOC nicht erwähnt.</em></p>
		<p>&#x00A0;</p>
		<hr/>
		
		
		
		<!-- ================================================================================================= -->
		
		<h2>Prüfbedingungen </h2>
		
		<p>Mit Hilfe einer Prüfbedingung / eines Checks kann über die Einbindung der gesamten Seite entschieden werden.
			Nützlich ist dies für Seiten, die abhängig vom Vorhandensein eines Wertes/Inhalt sein sollen. Bestes Beispiel
			ist hierfür z.B. die Autorenseite die nur generiert werden soll, wenn &#x3C;meta_e-bio> auch ausgefüllt ist.</p>
		<p>&#x00A0;</p>
		
		<p><strong>Beispiel:</strong></p>
		
		<div class="einschub code">
			<pre>&#x3C;head><br/>    &#x3C;title>Über {{&#x200A;AUTOR&#x200A;}}&#x3C;/title><br/>    &#x3C;check valueOf="meta_e-bio"/><br/>    ...</pre>
		</div>
		
		<p>Falls &#x3C;meta_e-bio> nun Inhalt enthält, wird das Template ganz normal verarbeitet und in TOC und OPF aufgenommen.
			Falls &#x3C;meta_e-bio> nicht existiert oder leer ist, wird das TPL-Template nicht weiter verarbeitet und somit nicht ins EPUB aufgenommen.</p>
		
		<div class="einschub infobox">
			<p><b>Erlaubt sind lediglich die Element-Aufrufe (<a href="90-tpl-doku1.xhtml#elementAufrufe">vollständige Liste hier</a>) – <i>keine</i> XPath-Abfragen!</b></p>
		</div>
		
	</body>
</html>